#import <UIKit/UIKit.h>
#import <Foundation/Foundation.h>
#include "basic_type_defs.h"
#include "game.h"

@class HiddenManagementView ;

@interface GameView : UIView {
  IBOutlet HiddenManagementView *hidden_management_view ;
  
  UILabel *score_label ;
  UILabel *performance_label ;
  UIProgressView *time_progressview ;
  UITextView *propositions_text ;
  UILabel *current_proposition_label ;
  UIButton *button_reset_current_proposition ;
  UIButton *button_letter0 ;
  UIButton *button_letter1 ;
  UIButton *button_letter2;
  UIButton *button_letter3 ;
  UIButton *button_letter4 ;
  UIButton *button_letter5 ;
  UIButton *button_letter6 ;
  UIButton *button_ok ;
  UIButton *button_back ;
  UIButton *button_shuffle ;
  UIButton *button_surrender ;
  NSTimer *timer_game ;
  /* Initialisez once the view is loaded. Use to speed-up buttons processing. */
  UIButton *button_letters_as_array[NB_LETTERS] ;  
}

@property (nonatomic, retain) IBOutlet UILabel *score_label ;
@property (nonatomic, retain) IBOutlet UILabel *performance_label ;
@property (nonatomic, retain) IBOutlet UIProgressView *time_progressview ;
@property (nonatomic, retain) IBOutlet UITextView *propositions_text ;
@property (nonatomic, retain) IBOutlet UILabel *current_proposition_label ;
@property (nonatomic, retain) IBOutlet UIButton *button_reset_current_proposition ;
@property (nonatomic, retain) IBOutlet UIButton *button_letter0 ;
@property (nonatomic, retain) IBOutlet UIButton *button_letter1 ;
@property (nonatomic, retain) IBOutlet UIButton *button_letter2 ;
@property (nonatomic, retain) IBOutlet UIButton *button_letter3 ;
@property (nonatomic, retain) IBOutlet UIButton *button_letter4 ;
@property (nonatomic, retain) IBOutlet UIButton *button_letter5 ;
@property (nonatomic, retain) IBOutlet UIButton *button_letter6 ;
@property (nonatomic, retain) IBOutlet UIButton *button_ok ;
@property (nonatomic, retain) IBOutlet UIButton *button_back ;
@property (nonatomic, retain) IBOutlet UIButton *button_shuffle ;
@property (nonatomic, retain) IBOutlet UIButton *button_surrender ;
@property(nonatomic,retain) NSTimer *timer_game ;


+ (void) showSimpleMessage: (NSString*) text ;
- (IBAction) letter_button_pressed_callback: (id) sender ;
- (IBAction) back_button_pressed_callback: (id) sender ;
- (IBAction) ok_button_pressed_callback: (id) sender ;
- (IBAction) shuffle_button_pressed_callback: (id) sender ;
- (IBAction) reset_current_proposition_button_pressed_callback: (id) sender ;
- (void) surrender_button_pressed_callback: (id) sender ;

- (IBAction) return_to_setup_view ;

@end
