/*
 *  persistent.c
 *  IBlabla
 *
 *  Created by Didou on 17/11/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "basic_type_defs.h"
#include "game.h"
#include "persistent.h"

struct HallOfFame global_hall_of_fame ;



struct list_item* list_from_contiguous_strings (char *buffer, int nb_strings,
  struct list_item** tail)
{
  struct list_item* head = NULL ;
  struct list_item* prev = NULL ;
  struct list_item* current_list_cell ;
  int i, string_len ;
  char *tmp_ptr = buffer ;
  
  for (i = 0; i < nb_strings; i++) {
    current_list_cell = (struct list_item*) malloc (sizeof (struct list_item)) ;
    if (current_list_cell == NULL) {
      popup_message (FALSE, "MÈmoire insuffisante.") ;
      FREEZE_ON_FAILURE ;
    }
    
    string_len = strlen (tmp_ptr) ;
    current_list_cell->item = (char*) malloc ((1 + string_len) * sizeof (char)) ;
    strcpy (current_list_cell->item, tmp_ptr) ;
    
    /* Link cells. */
    current_list_cell->next = NULL ;
    if (prev == NULL) {
      current_list_cell->prev = NULL ;
      head = current_list_cell ;
    }
    else {
      current_list_cell->prev = prev ;
      prev->next = current_list_cell ;
    }
    
    /* Make the pointer in the strings going further. */
    tmp_ptr = tmp_ptr + string_len + 1 ;
    prev = current_list_cell ;
  }
  
  *tail = current_list_cell ;
  return (head) ;
}



/* nb_strings and size are "out mode" parameters and are set by side effect. */
char* contiguous_strings_from_list (struct list_item *list, int *nb_strings,
                                    int *total_size)
{
  char *buffer, *tmp_ptr ;
  int local_total_size = 0 ;
  int local_nb_strings = 0 ;
  int string_len ;
  struct list_item *walker = list ;
  
  /* First, count the number of strings in the list and the total byte size
     they represent (with the final '\0' counted). */
  while (walker != NULL) {
    local_nb_strings++ ;
    local_total_size = local_total_size + 1 + strlen (walker->item) ;
    walker = walker->next ;
  }
  
  /* Now, allocate the buffer and fill it. */
  buffer = (char*) malloc (local_total_size * sizeof (char)) ;
  if (buffer == NULL) {
    popup_message (FALSE, "MÈmoire insuffisante.") ;
    FREEZE_ON_FAILURE ;
  }
  
  tmp_ptr = buffer ;
  walker = list ;
  while (walker != NULL) {
    string_len = strlen (walker->item) ;
    strcpy (tmp_ptr, walker->item) ;
    /* Increment the temporary pointer in the buffer by the size of the copied
       string + 1 byte. */
    tmp_ptr = tmp_ptr + string_len + 1 ;
    walker = walker->next ;
  }
  
  *total_size = local_total_size ;
  *nb_strings = local_nb_strings ;
  
  return (buffer) ;
}



BoolTy update_high_scores (struct game *game)
{
  short i, j ;
  
  /* Recherche d'un point d'entrée dans la table des highscores. */
  for (i = 0; i < NB_FAME_ENTRIES; i++) {
    if (game->score > global_hall_of_fame.entries[i].score) {
      /* Décalage des scores inférieurs. */
      for (j = NB_FAME_ENTRIES - 1; j > i; j--) {
        global_hall_of_fame.entries[j].score =
          global_hall_of_fame.entries[j - 1].score ;
        strcpy
          (global_hall_of_fame.entries[j].name,
           global_hall_of_fame.entries[j - 1].name) ;
      }
      global_hall_of_fame.entries[i].score = game->score ;
      strcpy (global_hall_of_fame.entries[i].name, "Foo") ;
      return (TRUE) ;
    }
  }
  
  /* Pas de highscore battu. */
  return (FALSE) ;
}
